
/**
 * 全局命名空间
 * base js for kzone 2012
 * @module			base.js based on jquery
 * @version			2012
 * @author 			xujz
 * @namespace KW
 */	
KW = {
	domain: 'kuwo.cn'
};

/**
 * 设置domain
 * @function KW.setKuwoDomain
 */
KW.setKuwoDomain = function() {
	document.domain = KW.domain;
}
/**
 * KW.setKuwoDomain();
 */

/** ******************************************************************************************************************************************************************************** */
/**
 * 配置相关
 * @namespace KW.CONF
 */
KW.CONF = {};
/**css基础路径，http://css.kuwo.cn */
KW.CONF.CSS_BASE_URL = 'http://css.kuwo.cn';
/**js基础路径http://js.kuwo.cn */
KW.CONF.JS_BASE_URL = 'http://js.kuwo.cn';
/**image基础路径，http://image.kuwo.cn */
KW.CONF.IMAGE_BASE_URL = 'http://image.kuwo.cn';
/**image基础路径*/
KW.CONF.IMG_BASE_URL = KW.CONF.IMAGE_BASE_URL;
/**mlog前缀，http://kzone.kuwo.cn/mlog */
KW.CONF.MLOG_PREF = 'http://kzone.kuwo.cn/mlog';
/**mlog前缀，http://kzone.kuwo.cn/mlog */
KW.CONF.MLOG_BASE = KW.CONF.MLOG_PREF;
/**空间前缀，http://kzone.kuwo.cn/mlog/u */
KW.CONF.PROFILE_PREF = 'http://kzone.kuwo.cn/mlog/u';

/** **************************************************************************************** */
/**
 * 调试相关
 * @namespace KW.debug
 */
KW.debug = {};
KW.debug.DEBUG_MODE = false;
KW.debug = {
	log : function() {},
	on : function() {
		KW.debug.DEBUG_MODE = true;
		if(window.console && console.log) {
			KW.debug.log = function(s) {
				console.log(s);
			};
		}
	},
	off : function() {
		KW.debug.log = function() {
		};
	}
};
KW.log = function(s) {
	KW.debug.log(s);
};

/** **************************************************************************************** */
/**
 * cookie相关
 * @namespace KW.cook
 */
KW.cook = {};

/**
 * 获取cookie
 * @function	KW.cook.getCookie
 * @param		{String}	cookieName	cookie名
 * @return		{String}	cookie值或者‘’
 */
KW.cook.getCookie = function(cookieName) {
    var arg = cookieName + "=";
    var alen = arg.length;
    var clen = document.cookie.length;
    //alert(document.cookie);
    var i = 0;
    while (i < clen) {
        var j = i + alen;
        if (document.cookie.substring(i, j) == arg) {
            var endstr = document.cookie.indexOf(";", j);
            if (endstr == -1) {
                endstr = document.cookie.length;
            }
            var ret = unescape(document.cookie.substring(j, endstr));
            if (ret != "") {
                return ret;
            }
        }
        i = document.cookie.indexOf(" ", i) + 1;
        if (i == 0) 
            break;
    }
    return "";
}

/**
 * 删除一个cookie
 * @function	KW.cook.delCookie
 * @param		{String}	cookieName	cookie名
 */
KW.cook.delCookie = function(cookieName) {
    var exp = new Date();
    exp.setTime(exp.getTime() - 100);
    document.cookie = cookieName + "=; path=/; domain=kuwo.cn; expires=" + exp.toGMTString();
    document.cookie = cookieName + "=; path=/; expires=" + exp.toGMTString();
    //alert(exp.toGMTString());
    //alert("after del : " + document.cookie);
}

/**
 * 添加一个cookie
 * @function	KW.cook.addCookie
 * @param {String} cookieName	cookie名
 * @param {String} cookieValue	cookie值
 */
KW.cook.addCookie = function(cookieName, cookieValue) {
    var expdate = new Date();
    var argv = arguments;
    var argc = arguments.length;
    var expires = (argc > 2 && argv[2] != 0) ? argv[2] : null;
    var path = (argc > 3) ? argv[3] : null;
    var domain = (argc > 4) ? argv[4] : null;
    var secure = (argc > 5) ? argv[5] : false;
    if (expires != null) {
        expdate.setTime(expdate.getTime() + (expires * 1000));
    }
    //set the domain!
    //domain = "kuwo.cn";
    //domain = null;
    document.cookie = cookieName + "=" + escape(cookieValue) +
    ((expires == null) ? "" : ("; expires=" + expdate.toGMTString())) +
    ((path == null) ? "" : ("; path=" + path)) +
    ((domain == null) ? "" : ("; domain=" + domain)) +
    ((secure == true) ? "; secure" : "");
    //alert(expdate.toGMTString());
    //alert(path);
    //alert(domain);
    //alert("after add : " + document.cookie);
}

/**
 * 检查用户是否登录
 * @function	KW.cook.isLogin
 * @retrun		用户登录：true；用户未登录：false
 */
KW.cook.isLogin = function() {
    if (KW.cook.getCookie('userid') == null || KW.cook.getCookie('userid') == '') {
        return false;
    }
    return true;
}

/**
 * 检查登录用户是否主人
 * @function	KW.cook.isLogin
 * @param 		{Integer}	uid		页面用户的id
 * @retrun		用户登录：true；用户未登录：false
 */
KW.cook.isHost = function(uid) {
	if(uid == null || isNaN(uid)) {
		return false;
	}
    if (uid == KW.cook.getCookie('userid')) {
        return true;
    }
    return false;
}

/**
 * 退出用户session
 * @function	KW.cook.logoutSession
 */
KW.cook.logoutSession = function(url, callback) {
	if(!callback) {
		window.location.href = 'http://i.kuwo.cn/US/st/Logout?returnUrl=' + encodeURIComponent(url);		
	} else {
		KW.cook.delCookie('userid');
		KW.cook.delCookie('username');
		KW.cook.delCookie('mlogdomain');
		KW.cook.delCookie('uph');
		KW.cook.delCookie('sid');
		if(typeof callback == 'function') {
			callback();			
		}
	}
//	delCookie('userid');
//	delCookie('username');
//	delCookie('mlogdomain');
//	delCookie('uph');
//	delCookie('sid');
}

/**
 * 更新last access time值
 * @function	KW.cook.updateSession
 */
KW.cook.updateSession = function() {
	if(KW.cook.getCookie('userid') != '' && KW.cook.getCookie('sid') != '') {
		var ss = new Image();
		ss.src = 'http://i.kuwo.cn/US/st/UpdateAccessTime?t=' + Math.random();
	} else {
		KW.cook.delCookie('userid');
		KW.cook.delCookie('username');
		KW.cook.delCookie('uph');
		KW.cook.delCookie('sid');
		KW.cook.delCookie('mlogdomain');
	}
}

KW.cook.updateSession();


/** ******************************************************************************************************************************************************************************** */

/**
 * 基本工具方法
 * @namespace KW.util
 */
KW.util = {};

/**
 * 禁止使用右键
 * @function	KW.util.disableRight
 */
KW.util.disableRight = function(){
	document.oncontextmenu = function() {
		return false;
	};
}

/**
 * getElementsByName统一的实现方式
 * @function	KW.util.getElementsByName
 * @param {String}	tag		标签
 * @param {String}	eltname	真正的name
 * @return {List}	标签为tag的name属性值为eltname的元素列表
 */
KW.util.getElementsByName = function(tag, eltname) {
	var elts = document.getElementsByTagName(tag);
	var count = 0;
	var elements = [];
	for (var i = 0; i < elts.length; i++) {
		if (elts[i].getAttribute('name') == eltname) {
			elements[count++] = elts[i];
		}
	}
	return elements;
}

/**
 * 添加此页至收藏夹
 * @function	KW.util.addFavorite
 * @param {String}	sURL	要收藏的url
 * @param {String}	sTitle	收藏夹中的标题
 */
KW.util.addFavorite = function(sURL, sTitle) {
	try {
		window.external.addFavorite(sURL, sTitle);
	} 
	catch (e) {
		try {
			window.sidebar.addPanel(sTitle, sURL, '');
		} 
		catch (e) {
// alert('what happened?');
		}
	}
	return false;
}

/**
 * 拷贝srcInfo到剪切板，并提示showInfo
 * @function	KW.util.copyToClipboard
 * @param {String}
 *            srcInfo	需要拷贝的内容
 * @param {String}
 *            showInfo	提示信息
 * @exception 在chrome下不可用，日后用flash版的拷贝到剪切板方法
 */
KW.util.copyToClipboard = function(srcInfo, showInfo) {
	if (window.clipboardData) {
		// window.clipboardData.clearData();
		window.clipboardData.setData("Text", srcInfo);
		KW.util.inf(showInfo);
	} else if (navigator.userAgent.indexOf('Opera') != -1) {
		window.location = srcInfo;
		KW.util.inf(showInfo);
		return true;
	} else if (window.netscape) {
		try {
			netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
		} catch (e) {
			KW.util.inf("您的firefox安全限制限制您进行剪贴板操作，请打开’about:config’将signed.applets.codebase_principal_support’设置为true’之后重试");
			return false;
		}
		var clip = Components.classes['@mozilla.org/widget/clipboard;1'].createInstance(Components.interfaces.nsIClipboard);
		if (!clip) 
			return false;
		var trans = Components.classes['@mozilla.org/widget/transferable;1'].createInstance(Components.interfaces.nsITransferable);
		if (!trans) 
			return false;
		trans.addDataFlavor('text/unicode');
		var str = new Object();
		var len = new Object();
		var str = Components.classes['@mozilla.org/supports-string;1'].createInstance(Components.interfaces.nsISupportsString);
		var copytext = srcInfo;
		str.data = copytext;
		trans.setTransferData('text/unicode', str, copytext.length * 2);
		var clipid = Components.interfaces.nsIClipboard;
		if (!clip) 
			return false;
		clip.setData(trans, null, clipid.kGlobalClipboard);
		KW.util.inf(showInfo);
		return true;
	}
};

/**
 * 获取当前时间的前几位值
 * @function	KW.util.getNowTime
 * @param {Integer} length
 * @return {String}	当前时间的前几位值
 */
KW.util.getNowTime = function(length) {
	var d = '' + new Date().getTime();
	if (length == null || length <= 0 || length >= 13) {
		return d;
	}
	return d.substring(0, length);
};

/**
 * 返回请求连接符
 * @function	KW.util.getRequestConnChar
 * @param {String}		url
 * @return	{String}	当url不含有"?"时返回"?"，否则返回"&"
 */
KW.util.getRequestConnChar = function(url) {
	var connectionChar = '&';
	if (url.indexOf('?') < 0) {
		connectionChar = '?';
	}
	return connectionChar;
};

/**
 * 获取url中某参数
 * @function	KW.util.getQueryVal
 * @param   	{String} url	目标url
 * @param		{String} key	参数名
 * @return		{String} key参数的值，如果不存在返回‘’  
 */
KW.util.getQueryVal = function(url, key) {
	if (!url || !key) {
		return '';
	}
	var qPos = url.lastIndexOf('?');
	if(qPos >= 0) {
		if(qPos < url.length - 1) {
			url = url.substring(qPos + 1);			
		} else {
			return '';
		}
	}
	var sPos = url.indexOf('#');
	if(sPos >= 0) {
		url = url.substring(0, sPos);
	}
	var v = '';
	var kPos = url.indexOf(key + '=');
	if(kPos < 0) {
		return '';
	}
	var s = '';
	var begin = kPos + key.length + 1;
	var nAnd = url.indexOf('&', begin);
	if(nAnd < 0) {
		s = url.substring(begin);
	} else {
		s = url.substring(begin, nAnd);
	}
	return s;
};

/**
 * 填充块内容的ajax请求
 * @function	KW.util.ajaxUpdate 
 * @param {String}
 *            method 请求方式，get或post
 * @param {String}
 *            retDiv 填充div的id
 * @param {String}
 *            url 请求的url
 * @param {String}
 *            arg 请求的参数：“id=22&uid=350582&cat=list”
 * @param {Function}
 *            onCompleteFunc 请求完成的处理
 * @param {Function}
 *            onErrorFunc 请求失败的处理
 * @param {Integer}
 *            cacheDuration 客户端需要缓存的时间（取时间的位数1-7），如果不需要缓存则传null
 * 			  由于客户端获取js时间不靠谱，导致服务器上会保存多个缓存副本。建议不采用。
 * @return {Object}	ajax对象
 */
KW.util.ajaxUpdate = function(method, retDiv, url, arg, onCompleteFunc, onErrorFunc, cacheDuration) {
	// 只有get方式请求才有可能缓存
	if (cacheDuration != null && cacheDuration > 0 && cacheDuration <= 7) {
		var cc = KW.util.getRequestConnChar(url);
		url += cc + 'ts=' + KW.util.getNowTime(cacheDuration);
	}
	var au = $.ajax({
		'type': (method != null && method == 'post')?'POST':'GET',
		'url': url,
		'data': arg,
//		'cache': (cacheDuration == null) ? false : true,
		'cache': true,
		'success': function(ret, rstt) {
			try {
				if(retDiv != null) {
					$('#' + retDiv).html(ret);			
				}					
			} catch(e) {}
			if(onCompleteFunc != null) {
				onCompleteFunc(ret, rstt);				
			}
		},
		'error': function(xhr, rstt, err) {
			if(onErrorFunc != null) {
				onErrorFunc(xhr, rstt, err);
			}
		}
	});
	return au;
};

/**
 * 不填充块内容的ajax请求
 * @function	KW.util.ajaxRequest 
 * @param {String}
 *            method 请求方式，get或post
 * @param {String}
 *            url 请求的url
 * @param {String}
 *            arg 请求的参数：“id=22&uid=350582&cat=list”
 * @param {Function}
 *            onCompleteFunc 请求完成的处理
 * @param {Function}
 *            onErrorFunc 请求失败的处理
 * @param {Integer}
 *            cacheDuration 客户端需要缓存的时间（取时间的位数1-7），如果不需要缓存则传null
 * 			  由于客户端获取js时间不靠谱，导致服务器上会保存多个缓存副本。建议不采用。
 * @return {Object}	ajax对象
 */
KW.util.ajaxRequest = function(method, url, arg, onCompleteFunc, onErrorFunc, cacheDuration) {
	return KW.util.ajaxUpdate(method, null, url, arg, onCompleteFunc, onErrorFunc, cacheDuration);
};

/**
 * 脚本跨域函数
 * @function	KW.util.crossDomainDo 
 * @param	{String}	script_e	脚本element
 * @param	{String}	path_s		请求url，返回值类似“var r = [{'city':'宝鸡','hasport':false},{cityname:'西安',airname:'西安咸阳机场',distance:147.3059}];”
 * @param	{Function}	callback_f	回调函数
 */
KW.util.crossDomainDo = function(script_e, path_s, callback_f) {/* shawl.qiu，void return，func:none */
	if(typeof script_e === 'string') {
		script_e = document.getElementById(script_e);
	}
	if(!script_e) {
		$('body').append(script_e = document.createElement('script'));
	}
	if(!callback_f) {
		callback_f = function() {}
	};
	script_e.onload = function() {
		callback_f();
	};
	script_e.onreadystatechange = function() {
		if(script_e.readyState == 'loaded') {
			callback_f();
		}
	};
	script_e.src = path_s;
}/* function script_cross_domain_f(script_e, path_s, callback_f) */


/** ******************************************************************************************************************************************************************************** */
/**
 * 样式相关
 * @namespace	KW.ui
 */
KW.ui = {};

/**
 * 返回一个jquery对象
 * @function KW.ui.getObj
 * @param	obj		如果是id字符串，返回id对应的jquery对象；如果是普通对象，返回jquery对象；如果找不到，返回null
 * @return	返回对应的jquery对象
 */
KW.ui.getObj = function(obj) {
	if(obj == null) {
		return null;
	}
	if(typeof obj == 'string') {
		obj = $('#' + obj);
	}
	if(obj == null) {
		return null;
	}
	return $(obj);
}

/**
 * 当用户中等头像load不到的时候就去读取大图，在onerror时才去调用此方法
 * @function KW.ui.tryImgB
 * @param {Object}
 *            ImgD
 */
KW.ui.tryImgB = function(ImgD) {
	if(ImgD == null) {
		return false;
	}
	var smallImg = ImgD.src;
	ImgD.onerror = null;
	if (smallImg.indexOf('m.jpg') != -1) {
		ImgD.src = smallImg.replace('m.jpg', 'b.jpg');
	}
}

/**
 * 按照比例调整图片大小，限定了最大的宽高，并且设置了marginLeft和marginTop
 * @function KW.ui.resizeImg
 * @param {Object}
 *            ImgD
 * @param {Integer}
 *            iwidth 图片最大宽度
 * @param {Integer}
 *            iheight 图片最大高度
 * @param {Integer}
 *            mleft 图片以正方形算的左边空白边
 * @param {Integer}
 *            mtop 图片以正方形算的顶部空白边
 */
KW.ui.resizeImg = function(ImgD, iwidth, iheight, mleft, mtop, setCenter) {
	if(ImgD == null) {
		return false;
	}
	var image = new Image();
	var src = ImgD.src;
	if(src.indexOf('trp.gif') > 0 || src.indexOf('1-1.gif') > 0) {
		src = $(ImgD).attr('sr') || $(ImgD).attr('data-url');
	}
	image.src = src;
	if(iwidth != 0 && iheight == 0) {
		iheight = (image.height*iwidth)/image.width;
	}
	if(iwidth == 0 && iheight != 0) {
		iwidth = (image.width*iwidth)/image.height;
	}
	$(ImgD).removeAttr('width');
	$(ImgD).removeAttr('height');
	if (image.width > 0 && image.height > 0) {
		if (image.width / image.height >= iwidth / iheight) {
			if (image.width > iwidth) {
				ImgD.width = iwidth;
				ImgD.height = (image.height * iwidth) / image.width;
			}
			else {
				ImgD.width = image.width;
				ImgD.height = image.height;
			}
		}
		else {
			if (image.height > iheight) {
				ImgD.height = iheight;
				ImgD.width = (image.width * iheight) / image.height;
			}
			else {
				ImgD.width = image.width;
				ImgD.height = image.height;
			}
		}
		// 过滤掉ImgD的width和height都为0的情况。在这种情况下ImgD会被默认图片替换		
		if (ImgD.width > 0 && ImgD.height > 0) {
			if(setCenter == null || setCenter) {
				ImgD.style.marginLeft = (iwidth - ImgD.width) / 2 + mleft + 'px';
				ImgD.style.marginTop = (iheight - ImgD.height) / 2 + mtop + 'px';
				ImgD.style.display = 'inline';			    
			    ImgD.parentNode.style.textAlign = 'left';
			}
		}
	}
	//解决chrome读取image.src的宽高都是0的问题
	else {
/*		ImgD.style.width = iwidth + 'px';
		ImgD.style.height = iheight + 'px';*/
		ImgD.style.marginLeft = mleft + 'px';
		ImgD.style.marginTop = mtop + 'px';
		ImgD.style.display = 'inline';
	    ImgD.parentNode.style.textAlign = 'left';
	}
};

/**
 * 获取默认图片
 * @function KW.ui.getDefaultImg
 * @param {Object}
 *            obj img对象
 * @param {Integer}
 *            width 默认图片宽度
 * @param {Integer}
 *            height 默认图片高度
 * @param {String}
 *            type 图片的类型（歌手头像，专辑图片，mv图片，用户头像）
 */
KW.ui.getDefaultImg = function(obj, width, height, type, setCenter, iType) {
	if(KW.ui.getObj(obj) == null) {
		return;
	};
	obj.onerror = null;
	var picUrl = '';
	var prefix = KW.CONF.IMG_BASE_URL + '/www/default/';
	var suffix = '.jpg';
	if(iType != null) {
		suffix = iType;
	}
	var w = width;
	var h = height;
	if(w == null || isNaN(w) || h == null || isNaN(h)) {
		return;
	}
	var name = w + '-' + h + '-' + type;
	picUrl = prefix + name + suffix;
	obj.src = picUrl;
	obj.style.width = w + 'px';
	obj.style.height = h + 'px';
};

/**
 * 显示某元素为block
 * @function KW.ui.show
 * @param	{Object}	obj
 */
KW.ui.show = function(obj) {
	if(KW.ui.getObj(obj) == null) {
		return;
	};
	$(obj).removeClass('undis');
	$(obj).removeClass('disin');
	$(obj).addClass('dis');
};

/**
 * 显示某元素为inline
 * @function KW.ui.showin
 * @param	{Object}	obj
 */
KW.ui.showin = function(obj) {
	if(KW.ui.getObj(obj) == null) {
		return;
	};
	$(obj).removeClass('undis');
	$(obj).removeClass('dis');
	$(obj).addClass('disin');
};

/**
 * 隐藏某元素
 * @function KW.ui.hide
 * @param	{Object}	obj
 */
KW.ui.hide = function(obj) {
	if(KW.ui.getObj(obj) == null) {
		return;
	};
	$(obj).removeClass('dis');
	$(obj).removeClass('disin');
	$(obj).addClass('undis');
};

/**
 * 显示某元素，使用visibility属性
 * @function KW.ui.vis
 * @param	{Object}	obj
 */
KW.ui.vis = function(obj) {
	if(KW.ui.getObj(obj) == null) {
		return;
	};
	$(obj).removeClass('unvis');
	$(obj).addClass('vis');
};

/**
 * 隐藏某元素，使用visibility属性
 * @function KW.ui.unvis
 * @param	{Object}	obj
 */
KW.ui.unvis = function(obj) {
	if(KW.ui.getObj(obj) == null) {
		return;
	};
	$(obj).removeClass('vis');
	$(obj).addClass('unvis');
};

/**
 * 设置居中
 * @function KW.ui.setCenter
 * @param {Object} obj	目标对象
 * @param {Integer} leftWidth 左边调整量
 */
KW.ui.setCenter = function(obj, leftWidth) {
	if(KW.ui.getObj(obj) == null) {
		return;
	};
	obj = obj.get(0);
	obj.style.position = 'absolute';
	var cw = $(window).width();
	var ch = $(window).height();

	var sl = $(window).scrollLeft();
	var st = $(window).scrollTop();

	//整个页面的中间
	var left = 0;
	if(leftWidth == null || isNaN(leftWidth)) {
		left = parseInt((cw - $(obj).width()) / 2) + sl + 'px';
	} else {//右侧区域的中间
		left = parseInt((cw - $(obj).width() + leftWidth) / 2) + sl + 'px';
	}
	var top = parseInt((ch - $(obj).height()) / 2) + st + 'px';

	$(obj).css('left', left);
	$(obj).css('top', top);
};

/**
 * 设置在e的位置
 * @function KW.ui.setCenter
 * @param {Object} obj	触发的对象
 * @param {Event} e	触发的事件
 * @param {Integer} ignoreElementDem	左边调整量
 */
KW.ui.setPos = function(obj, e, ignoreElementDem) {
	if(KW.ui.getObj(obj) == null) {
		return;
	};
	obj.css({'position': 'absolute'});
	var cw = $(window).width();
	var ch = $(window).height();
	var sl = $(window).scrollLeft();
	var st = $(window).scrollTop();
	if(e && typeof e.pageX != 'undefined') {
		//鼠标位置
		var px = e.pageX;
		var py = e.pageY;

		if(!ignoreElementDem) {
			//对象长宽
			var ox = obj.width();
			var oy = obj.height();	
			if(px + ox > cw + sl) {
				px = cw + sl - ox;
			}
			if(py + oy > ch + st) {
				py = ch + st - oy;
			}		
		}	
		var left = px + 'px';
		var top = py + 'px';
		obj.get(0).style.left = left;
		obj.get(0).style.top = top;		
	} else {
		KW.ui.setCenter(obj, ignoreElementDem);
	}
};

/**
 * 通用确认提示框
 * 如果之前存在，则将之前的提示框取消
 * @function KW.ui.con
 * @param {String} ins	提示文字
 * @param {Event} e		触发事件
 * @param {Function} doFunc	确认执行的函数
 * @param {Function} cancelFunc	取消执行的函数
 */
KW.ui.con = function(ins, e, doFunc, cancelFunc) {
	var cb = $('#confirmBox');
	if(cb) {
		cb.remove();
	}
	/*
	  <div class="trpBorderFrm2">
        <table width="100%" border="0" cellspacing="0" cellpadding="0">
                  <tbody><tr>
                        <td colspan="3" class="crBg"></td>
                  </tr>
                  <tr>
                        <td class="crLeft"></td>
                        <td>
                            <div class="bodCont">
                                <div class="tipsModeFrm">
                                          <em class="cautionIcn"></em><span class="tsInfo">确定不再关注陆虎？</span>
                                    </div>
                                    <p class="newModelFrm"><a href="#@" id="cbOk" class="newModeBtn mr10">确 定</a><a href="#@" id="cbCancel" class="newModeBtn">取 消</a></p>
                              </div>  
                        </td>
                        <td class="crRight"></td>
                  </tr>
                  <tr>
                        <td colspan="3" class="crBg"></td>
                  </tr>
            </tbody></table>
      </div>
	*/
	var ctt = '<table width="100%" border="0" cellspacing="0" cellpadding="0"><tbody><tr><td colspan="3" class="crBg"></td></tr><tr><td class="crLeft"></td><td><div class="bodCont"><div class="tipsModeFrm"><em class="cautionIcn"></em><span class="tsInfo">'
	 + ins + '</span></div><p class="newModelFrm"><a href="#@" id="cbOk" class="newModeBtn mr10">确 定</a><a href="#@" id="cbCancel" class="newModeBtn">取 消</a></p></div></td><td class="crRight"></td></tr><tr><td colspan="3" class="crBg"></td></tr></tbody></table>';	
	var resultObj = document.createElement('div');
	resultObj.className = 'trpBorderFrm2 undis';
	resultObj.style.zIndex = '99999';
	resultObj.id = 'confirmBox';
	resultObj.innerHTML = ctt;

	$('body').append(resultObj);
	$(resultObj).fadeIn('fast');
	
	e = e || window.event;
	KW.ui.setPos($('#confirmBox'), e);
	
	if(doFunc != null) {
		$('#cbOk').click(function() {
			var cb = $('#confirmBox');
			if(cb) {
				$('#confirmBox').fadeOut('fast', function() {
					cb.remove();					
				});
			}
			doFunc();
		});
	}
	if(cancelFunc != null) {
		$('#cbCancel').click(function() {
			var cb = $('#confirmBox');
			if(cb) {
				$('#confirmBox').fadeOut('fast', function() {
					cb.remove();					
				});
			}
			cancelFunc();
		});
	} else {
		$('#cbCancel').click(function() {
			var cb = $('#confirmBox');
			if(cb) {
				$('#confirmBox').fadeOut('fast', function() {
					cb.remove();
				});
			}
		});
	}
};

/**
 * 隐藏通用确认提示框
 * @function KW.ui.hideCon
 */
KW.ui.hideCon = function() {
	var cb = $('#confirmBox');
	if(cb) {
		$('#confirmBox').fadeOut('fast', function() {
			cb.remove();
		});
	}
};

/**
 * 通用弹窗
 * 单例模式：当有其它弹窗时，不响应
 * @function KW.ui.showPopWin
 * @param {String} popTitle		标题
 * @param {String} popInfo		内容
 * @param {Function} doFunc		确认执行的函数
 * @param {Function} cancelFunc	取消执行的函数
 */
KW.ui.showPopWin = function(popTitle, popInfo, doFunc, cancelFunc) {
	//保证当有其它弹窗时，不响应
	if($('#popWin') != null) {
//		$('#popWin').remove();
		return;
	}
	var html = '<div class="topTit"><strong id="pop_title">'+popTitle+'</strong><a href="#nogo" onclick="KW.ui.hidePopWin()" class="blueClose"></a></div>';
	html += '<p class="h101">'+popInfo+'</p>';
	html += '<p class="botTit"><a id="popWinOk" href="#nogo" class="qdBtn">确定</a><a id="popWinCancel" href="#nogo" class="qdBtn">取消</a></p>';
	var popWin = document.createElement('div');
	popWin.id = 'popWin';
	popWin.className = 'w318';
	popWin.innerHTML = html;
	$('body').append(popWin);
	if(doFunc != null) {
		$('#popWinOk').onclick = doFunc;
	}
	if(cancelFunc != null) {
		$('#popWinCancel').onclick = function() {
			KW.ui.hidePopWin();
			cancelFunc();
		}
	} else {		
		$('#popWinCancel').onclick = KW.ui.hidePopWin;
	}
	KW.ui.setCenter($('#popWin'));
};

/**
 * 隐藏弹窗
 * @function KW.ui.hidePopWin
 */
KW.ui.hidePopWin = function() {
	if($('#popWin') == null) {
		return;
	}
	$('#popWin').remove();
};

KW.ui.popInfListener = null;

/**
 * 提示消息
 * @function KW.ui.showPopInf
 * @param {String} type		成功：'ok'；失败：'err'
 * @param {String} result	提示信息
 * @param {Function} func		之后的操作
 * @param {Integer} timespan	显示时长（ms）
 * @param {Integer} leftWidth	左边的调整量
 */
KW.ui.showPopInf = function(type, inf, func, timespan, leftWidth) {
	var mp = document.getElementById('MediaPlayer');
	if(mp != null) {
		mp.style.visibility = 'hidden';
	}
	/*
    <div class="trpBorderFrm2">
        <table width="100%" border="0" cellspacing="0" cellpadding="0">
                  <tbody><tr>
                        <td colspan="3" class="crBg"></td>
                  </tr>
                  <tr>
                        <td class="crLeft"></td>
                        <td>
                            <div class="bodCont">
                                <p class="tipsModeFrm">
                                          <em class="errIcn"></em><span class="tsInfo">添加成功！</span>
                                    </p>
                              </div>  
                        </td>
                        <td class="crRight"></td>
                  </tr>
                  <tr>
                        <td colspan="3" class="crBg"></td>
                  </tr>
            </tbody></table>
    </div>
    */    
    var icn = '';
    if(type == 'ok') {
        icn = 'okIcn';
    } else if(type == 'err') {
        icn = 'errIcn';
    } else if(type == 'inf' || type == 'warn') {
        icn = 'tsIcn';
    }
	var html = '<table width="auto" border="0" cellspacing="0" cellpadding="0"><tbody><tr><td colspan="3" class="crBg"></td></tr><tr><td class="crLeft"></td><td><div class="bodCont"><p class="tipsModeFrm"><em class="'
	 + icn + '"></em><span class="tsInfo">'
	 + inf + '</span></p></div></td><td class="crRight"></td></tr><tr><td colspan="3" class="crBg"></td></tr></tbody></table>';
	var resultObj = document.createElement('div');
	resultObj.id = 'popResult';
	resultObj.className = 'trpBorderFrm2 undis';
	if(type == 'ok') {
		resultObj.className = 'trpBorderFrm2 okBox undis';
	}
	resultObj.innerHTML = html;
	resultObj.style.zIndex = '99999';

	if(KW.ui.popInfListener || $('#popResult')) {
		$('#popResult').remove();
		clearTimeout(KW.ui.popInfListener);
		KW.ui.popInfListener = null;
	}
	$('body').append(resultObj);
	$(resultObj).fadeIn('fast');
	KW.ui.setCenter($('#popResult'), leftWidth);

	KW.ui.popInfListener = setTimeout(function() {
		var mp = document.getElementById('MediaPlayer');
		if(mp != null) {
			mp.style.visibility = 'visible';
		}
		clearTimeout(KW.ui.popInfListener);
		KW.ui.popInfListener = null;
		if(func != null) {
			func();
		}
		if($('#popResult')) {
			$('#popResult').fadeOut('fast', function() {
				$('#popResult').remove();
			});
		}
	}, (timespan==null || isNaN(parseInt(timespan)))?2000:parseInt(timespan));
};

/**
 * 隐藏提示消息
 * @function KW.ui.hidePopInf 
 */
KW.ui.hidePopInf = function() {
	var mp = document.getElementById('MediaPlayer');
	if(mp != null) {
		mp.style.visibility = 'visible';
	}
	if($('#popResult')) {
		$('#popResult').fadeOut('fast', function() {
			$('#popResult').remove();
			clearTimeout(KW.ui.popInfListener);
			KW.ui.popInfListener = null;
		});
	}
};

/**
 * 显示图片
 * @function KW.ui.getImgs
 * @param {List} imgs			需要显示的图片对象的list
 * @param {Integer} w			宽
 * @param {Integer} h			高
 * @param {String} cat			类型：'album','star','pl','mv'等
 * @param {Boolean} setCenter	是否居中
 * @param {Boolean} scrollLoad	true采用滚动加载，false直接加载
 * @param {Boolean} needResize	true需要resize，false不需要resize
 */
KW.ui.getImgs = function(imgs, w, h, cat, setCenter, scrollLoad, needResize) {
	if(imgs == null || imgs.length == 0) {
		return;
	}

	for(var i = 0; i < imgs.length; i++) {
		var src = $(imgs[i]).attr('sr');
		src = src || $(imgs[i]).attr('data-url');
		if(src == null || src == '') {
			continue;
		}
		w = (w == null ? '0' : w);
		h = (h == null ? '0' : h);
		if(w == '' || h == '') {
			continue;
		}
		imgs[i].onerror = (function() {
			var that = imgs[i];
			return function() {
				that.onerror = null;
				KW.ui.getDefaultImg(that, w, h, cat, setCenter);
				return false;
			};
		})();
		
		if(!scrollLoad) {
            if(needResize) {
                imgs[i].onload = (function() {
                        var that = imgs[i];
                        return function() {
                            KW.ui.resizeImg(that, w, h, 0, 0, setCenter);
                            return false;
                        };
                })();
            }
			$(imgs[i]).attr('src', src);
            if(needResize) {
                if(imgs[i].complete) {
                    KW.ui.resizeImg(imgs[i], w, h, 0, 0, setCenter);
                }
            }
		}
	}
	if(scrollLoad) {
		KW.ui.scrollLoading(imgs, w, h, setCenter, needResize);		
	}
};

/**
 * 滚动方式加载图片
 * @function KW.ui.scrollLoading
 * @param {List} objList		图片对象list
 * @param {Integer} w			宽
 * @param {Integer} h			高
 * @param {Boolean} setCenter	是否居中
 * @param {Boolean} needResize	true需要resize，false不需要resize
 */
KW.ui.scrollLoading = function(objList, w, h, setCenter, needResize) {
	if(objList == null || objList.length == 0) {
		return;
	}
	var params = {};
	params.cache = [];
	for(var i = 0; i< objList.length; i++) {
		var node = objList[i].nodeName.toLowerCase(), url = $(objList[i]).attr('data-url');
		if (!url) {
			continue;
		}
		//重组
		var data = {
			obj: objList[i],
			tag: node,
			url: url
		};
		params.cache.push(data);	
	}
	
	//动态显示数据
	var loading = function() {
		var st = $(window).scrollTop(), sth = st + $(window).height();
		for(var i=0; i < params.cache.length; i++) {
			var data = params.cache[i];
			var o = data.obj, tag = data.tag, url = data.url;
			if (o) {				
				post = $(o).offset().top; posb = post + $(o).height();
				//在浏览器窗口内
				if ((post > st && post < sth) || (posb > st && posb < sth)) {
					//resize和置中
					if(needResize == null || needResize == true) {
						o.onload = (function() {
								var that = o;
								return function() {
									KW.ui.resizeImg(that, w, h, 0, 0, setCenter);
									return false;
								};
						})();
					}
					if (tag === 'img') {
						//图片，改变src
						o.src = url;
					} else {
//						o.load(url);
					}
                    if(needResize == null || needResize == true) {
                        if(o.complete) {
                            KW.ui.resizeImg(o, w, h, 0, 0, setCenter);
                        }
                    }
					data.obj = null;
				}
			}
		}
		return false;
	};
	
	//事件触发
	//加载完毕即执行
	loading();
	//滚动执行
	$(window).scroll(function() {
	    loading();
    });
};


/**
 * 为主人显示当前页面的管理链接
 * @function KW.ui.addManLinks
 */
KW.ui.addManLinks = function() {
	if ($('#uid') == null) {
		return false;
	}
	if (KW.cook.isHost($('#uid').val())) {
		var links = KW.util.getElementsByName('a', 'manLink');
		for (var i = 0; i < links.length; i++) {
			links[i].style.display = 'inline';
		}
		var links = KW.util.getElementsByName('span', 'manLink');
		for (var i = 0; i < links.length; i++) {
			links[i].style.display = 'inline';
		}
		links = KW.util.getElementsByName('em', 'manLink');
		for (var i = 0; i < links.length; i++) {
			links[i].style.display = 'inline';
		}
	}
};


/** ******************************************************************************************************************************************************************************** */
/**
 * 表情
 * @constructor KW.ui.Em
 * @param {Object} form			需要表情的form对象
 * @param {Object} showFace		插入表情的按钮对象
 */
KW.ui.Em = function(form, showFace) {
	if(form) {
		this.form = form;		
	}	
	//表情参数
	if(showFace) {
		this.insertFace = showFace;
		this.faceTipsDivId = showFace.attr('faceTipsDivId');
		this.faceViewPId = showFace.attr('faceViewPId');
		this.faceViewImgId = showFace.attr('faceViewImgId');
		this.faceLoadingImgId = showFace.attr('faceLoadingImgId');
		this.faceTabId = showFace.attr('faceTabId');
		this.faceDivId = showFace.attr('faceDivId');
		this.facePopInited = false;		
	}
};

KW.ui.Em.prototype.genPop = function(divId) {
	var popDiv = document.createElement('div');
	popDiv.className = '';
	popDiv.setAttribute('id', divId);
	popDiv.style.display = 'none';
	var htm = '<div class="" id="' + divId + 'Content"></div>';
	popDiv.innerHTML = htm;
	$('body').append(popDiv);
	return divId + 'Content';
};

KW.ui.Em.prototype.hideTips = function() {
	if($('#' + this.faceTipsDivId)) {
		$('#' + this.faceTipsDivId).css({'display':'none'});		
	}
};

KW.ui.Em.prototype.genInsertFacePop = function() {
	var inTipsId = this.genPop(this.faceTipsDivId);
	var htm = '<div id="' + this.faceTabId + '" class="tw_box3" style="position:absolute;left:-118px;top:203px;z-index:1001;width:317px;"><span class="boxabs"></span><a href="#@" class="tw_closeBtn" onclick="$(\'#' + this.faceTipsDivId + '\').css({\'display\':\'none\'}); return false;"></a>';
    htm += '<div class="tw_clo" id="' + this.faceTabId + '"><p class="mt20">';
	htm += '	<div style="position:relative;overflow:hidden;clear:both;" id="' + this.faceDivId + '">'; 
	htm += '		<div class="faceView pab" id="' + this.faceViewPId + '" style="display:none;border:1px solid black;background:#fff;width:45px;height:45px;padding:2px;text-align:center;"><img src="http://image.kuwo.cn/blank.gif" id="' + this.faceViewImgId + '" style="padding-top:0;display:none"/><img src="http://image.kuwo.cn/loading.gif" id="' + this.faceLoadingImgId + '"  style="padding-top:15px"/></div>';
	htm += '	</div>';
    htm += '</div></div>';
	$('#' + inTipsId).html(htm);
	return;
};

/**
 * 显示表情相关的浮层
 * @method	KW.ui.Em.prototype.showInsertFace
 * @param	{Event}	e	点击事件
 * @param	{Object}	target	要加入表情的目标对象
 */
KW.ui.Em.prototype.showInsertFace = function(e, target) {
	if(!this.facePopInited) {
		this.genInsertFacePop();
		this.facePopInited = true;
	}
	this.hideTips();
	$('#' + this.faceTipsDivId).css({'display':''});
	this.loadFaceTab();
	e = e || window.event;
	var cw = $(window).width();
	var ch = $(window).height();
	var sl = $(window).scrollLeft();
	var st = $(window).scrollTop();
	//鼠标位置
	var top = e.pageY;
	var left = e.pageX;
	$('#' + this.faceTabId).css({'top': (top + 15) + 'px', 'left': (left - 15) + 'px'});
	if(target != null) {
		this.faceTarget = target;
	}
};

/**
 * 显示分类的表情
 */
KW.ui.Em.prototype.loadFaceTab = function() {
	if(!this.faceTabLoaded) {
		var len = KW_FACE.faceList.length;
		var htm = '';
		for(var i = 0; i < len; i++) {
			if(i >= 1) {
				htm += '<span class="vLine"> | </span>';
			}
			htm += '<a href="#@" class="faceA" id="KWSmileA' + i + '" id="' + i + '" onfocus="this.blur();">' + KW_FACE.faceList[i].title + '</a>';
		}
		$('#' + this.faceTabId).html(htm + $('#' + this.faceTabId).html());
		var that = this;
		for(var i = 0; i < len; i++) {
			$('#KWSmileA' + i).click((function() {
				var j = i;
				return function() {
					that.loadFaceList(j);
				}
			})());
		}
		this.faceTabLoaded = true;
	}
	var that = this;
	setTimeout(function() {
		that.loadFaceList(0);
	}, 50);
};

KW.ui.Em.prototype.loadFaceList = function(id) {
	if(id > KW_FACE.faceList.length) {
		return false;
	}
	$('#' + this.faceViewPId).css({'display':'none'});
	for(var i = 0; i < KW_FACE.faceList.length; i++) {
		$('#KWSmileA' + i).css({'font-weight':'normal'});
		if($('#KWFaceUl' + i)) {
			$('#KWFaceUl' + i).css({'display':'none'});
		}
	}
	$('#KWSmileA' + id).css({'font-weight':'bold'});
	if($('#KWFaceUl' + id) && KW_FACE.faceList[id].loaded) {
		$('#KWFaceUl' + id).css({'display':''});
		return;
	}
	var face = KW_FACE.faceList[id];
	var htmArray = new Array();
	var fc = face.faceCount;
	var lihtm = null;
	//默认表情
	if(id == '0') {
		lihtm = '<li style="float:left;display:inline;width:' + (face.listImgSize + 5) + 'px;height:' + (face.listImgSize + 2) + 'px">';
	}
	//兔斯基
	else {
		lihtm = '<li style="float:left;display:inline;width:' + (face.listImgSize + 2) + 'px;height:' + (face.listImgSize + 4) + 'px">';
	}
	var faceEachLine = 10;
	if(id == '1') {
		faceEachLine = 8;
	}
	for(var i = 0; i < fc; i++) {
		var faceUrl = face.faceUrlPre + i + face.faceUrlSuf;
		var lihtmArray = new Array();
		lihtmArray[0] = lihtm;
		lihtmArray[1] = '<a href="#@" show="' + (i%faceEachLine<(faceEachLine/2)?'right':'left') + '" furl="' + faceUrl + '" ';
		lihtmArray[2] = ' style="float:left;width:' + face.listImgSize + 'px;height:' + face.listImgSize + 'px; background:url(' + face.listImgSrc + ') no-repeat scroll left top transparent;background-position: left -' + face.listImgSize*i + 'px;"></a></li>';
		htmArray[i] = lihtmArray.join('');
	}
	var faceul = document.createElement('ul');
	if(id == '0') {
		faceul.style.marginLeft = '5px';
	}
	if(id == '1') {
		faceul.style.marginLeft = '3px';
	} 
	faceul.className = 'faceUl';
	faceul.id = 'KWFaceUl' + id;
	faceul.innerHTML = htmArray.join('');
	$('#' + this.faceDivId).append(faceul);
	var aList = $('#' + this.faceDivId + ' a');
	var aLen = aList.length;
	var that = this;
	for(var i = 0; i < aLen; i++) {
		aList[i].onclick = (function() {
			var a = aList[i];
			return function() {
				that.doInsertFace(a, a.getAttribute('furl'));				
			}
		})();
		aList[i].onmouseover = (function() {
			var a = aList[i];
			return function() {
				that.facePreview(a, a.getAttribute('furl'));			
			}
		})();
	}
	KW_FACE.faceList[id].loaded = true;
};

KW.ui.Em.prototype.facePreview = function(dom, url) {
	var left = 0;
	var top = 0;
	var show = dom.getAttribute('show');
	if(show == 'right') {
		left = 265;
	}	
	$('#' + this.faceViewPId).css({'left':left + 'px', 'top':top + 'px'});
	$('#' + this.faceLoadingImgId).css({'display':''});
	$('#' + this.faceViewImgId).css({'display':'none'});

	//默认表情
	if(url.indexOf('normal') > 0) {
		$('#' + this.faceViewImgId).css({'padding-top':'10px'});		
	}
	//兔斯基
	else {
		$('#' + this.faceViewImgId).css({'padding-top':'1px'});		
	}
	$('#' + this.faceViewImgId).attr('src', url);
	var that = this;
	$('#' + this.faceViewImgId).load(function() {
		$('#' + that.faceLoadingImgId).css({'display':'none'});
		$(this).css({'display':''});
		$(this).load(function() {});
	});
	$('#' + this.faceViewPId).css({'display':''});
};

/**
 * 插入表情
 */
KW.ui.Em.prototype.doInsertFace = function(dom, url) {
	$('#' + this.faceTipsDivId).css({'display':'none'});
	var em = url;
	//默认表情
	if(em.indexOf('normal') > 0) {
		em = '[' + em.substring(em.lastIndexOf('/') + 1, em.lastIndexOf('.')) + ']';
	}
	//兔斯基
	else {
		em = '[' + em.substring(em.lastIndexOf('/') + 1, em.lastIndexOf('.')) + ']';
	}
	if(typeof this.faceTarget == undefined || this.faceTarget == null) {
		this.paste(em);
		this.form['ctt'].focus();
	} else {
		this.paste(em, this.faceTarget);
		this.faceTarget.focus();
	}
};

KW.ui.Em.prototype.getCursortPosition = function(ctrl) {
    var CaretPos = 0;   // IE Support
    if (document.selection) {
    	ctrl.focus ();
        var Sel = document.selection.createRange ();
        Sel.moveStart ('character', -ctrl.value.length);
        CaretPos = Sel.text.length;
    }
    // Firefox support
    else if (ctrl.selectionStart || ctrl.selectionStart == '0')
        CaretPos = ctrl.selectionStart;
    return (CaretPos);
};

KW.ui.Em.prototype.paste = function(str, target) {
	if(target == null) {
	    if ($.browser.msie) {
	    	this.form['ctt'].focus();   
			clipboardData.setData("text", str);
			document.execCommand("paste");	    	
	    } else {
	    	this.form['ctt'].focus();
	    	document.execCommand('insertHTML', false, str);
	    }
	} else {
	    if ($.browser.msie) {
			this.faceTarget.focus();
			clipboardData.setData("text", str);
			document.execCommand("paste");
	    } else {
	    	this.faceTarget.focus();
	    	document.execCommand('insertHTML', false, str);
	    }		
	}
};

/**********************************************************
 * 表情系列列表
 * @namespace KW_FACE
 */
var KW_FACE = {};

/**
 * 表情列表
 * @member KW_FACE.faceList
 */
KW_FACE.faceList = [
    {
    	title:'默认表情',
    	listImgSrc:'http://image.kuwo.cn/kwEditor/em/normal/normal.png',
        listImgSize:24,
        faceCount:90,
        faceUrlPre:'http://image.kuwo.cn/kwEditor/em/normal/em',
        faceUrlSuf:'.gif',
        faceSize:24,
        loaded:false
    },
    {
    	title:'兔斯基',
    	listImgSrc:'http://image.kuwo.cn/kwEditor/em/rab/rab.gif',
        listImgSize:35,
        faceCount:40,
        faceUrlPre:'http://image.kuwo.cn/kwEditor/em/rab/t',
        faceUrlSuf:'.gif',
        faceSize:40,
        loaded:false
    }
];
